#include <windows.h>				// 
#include <winbase.h>				// 
#include <stdlib.h>	
#include "resource.h"
#include "Set1D_def.h"
#include "OBRREQ.h"
#include <commctrl.h>
#include <prsht.h>                   // vpeB V[g̃CN[h
#include <Winuser.h>

#define MAX_LOADSTRING 100

// Global Variables:


DWORD	dwOnoffsw = 0 ;						// 02.11.15 ADD
DWORD	gdwCdOpActFlg = 0 ;					// ޵߼ݐݒ豸è׸02.11.29 ADD

extern HINSTANCE		hInst;			// The current instance
extern HWND				hwndCB;			// The command bar handle

// Code Setting
extern int	gnowCode;
extern int	gnowCodeCheckDigit ;
extern int	gnowCodeOutFormat ;
extern int	gnowCodeReadMode ; 
extern int	gnowCodeBuzzer ;
extern int	gnowCodeLed ;
extern int	gnowCodeOutBuff ;
extern int	gnowCodeEndCode ;
extern int	gnowCodeReadActMode ;
extern int	gnowFilterMode ;						// 02.12.20 ADD



extern struct CODEPARAM	cparam[NUM_SYMBOLOGIES];	// Code Parameter
extern struct CODEONOFF	codeonoff[NUM_SYMBOLOGIES];	// Code Enable/Disble

// Code Range / min digit / max digit
extern const int iMin[NUM_SYMBOLOGIES] ;
extern const int iMax[NUM_SYMBOLOGIES] ;

extern const int iMinOnOff[NUM_SYMBOLOGIES] ;
extern const int iMaxOnOff[NUM_SYMBOLOGIES] ;
extern const int iOutFormatOnOff[NUM_SYMBOLOGIES] ;
extern const int iCheckDigitOnOff[NUM_SYMBOLOGIES] ;
extern const int iCheckCharOnOff[NUM_SYMBOLOGIES] ;



// R[h̎
extern const TCHAR CodeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CmbOrder[NUM_SYMBOLOGIES] ;

extern int Order1D[14] ;


extern const int iOutFormatSize[NUM_SYMBOLOGIES] ;
// OUTFORMAT CODE39̎
extern const TCHAR OutFomatCd39List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatCd39Order[NUM_SYMBOLOGIES] ;
// OUTFORMAT NW7̎
extern const TCHAR OutFomatNw7List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatNw7Order[NUM_SYMBOLOGIES] ;
// OUTFORMAT CODE128̎
extern const TCHAR OutFomatCd128List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatCd128Order[NUM_SYMBOLOGIES] ;
extern const int iCheckDigitSize[NUM_SYMBOLOGIES] ;
// Check Digit MSI̎
extern const TCHAR CheckDigitMsiList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitMsiOrder[NUM_SYMBOLOGIES] ;
// Check Digit IATA̎
extern const TCHAR CheckDigitIataList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitIataOrder[NUM_SYMBOLOGIES] ;
// Check Digit ̑̎
extern const TCHAR CheckDigitAnyList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitAnyOrder[NUM_SYMBOLOGIES] ;
// ǂݎ胂[h ̎
extern const TCHAR ReadModeList[NUM_SYMBOL_RDMODE][32] ;
// Combobox Order
extern int ReadModeOrder[NUM_SYMBOL_RDMODE] ;
// uU[ ̎
extern const TCHAR BuzzerList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int BuzzerOrder[NUM_SYMBOLOGIES] ;
// kdc ̎
extern const TCHAR LedList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int LedOrder[NUM_SYMBOLOGIES] ;
// o̓obt@ ̎
extern const TCHAR OutBuffList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutBuffOrder[NUM_SYMBOLOGIES] ;
// ǂݎ蓮샂[h ̎
extern const TCHAR ReadActModeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int ReadActModeOrder[NUM_SYMBOLOGIES] ;
// IR[h ̎
extern const TCHAR EndCodeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int EndCodeOrder[NUM_SYMBOLOGIES] ;

// tB^[h ̎ 02.12.20 ADD
extern const TCHAR FilterModeList[NUM_SYMBOLOGIES][32];
extern int FilterModeOrder[NUM_SYMBOLOGIES] ;


extern int giInidefFlag  ;						// ini File ݒ FLAG

extern DWORD	gdwCdActFlg ;					// ޗLݒ豸è׸02.11.29 ADD

extern const	struct	m_tbl	ObrModeTblDef ;
extern struct	m_tbl	ObrModeTbl ;


extern void ShowParamCodeConfig(HWND, int, int) ;
extern void TST_GetCodests(void);				// CODEL/ݒ擾
extern void TST_GetCodeOption(void) ;			// CODEIvVL/ݒ擾
extern int ini_FileWrite_Proc(void) ;			//
extern void TST_GetCodests2(int) ;				// 02.11.28 ADD
extern int	TST_SetCodeOptinGet(HWND) ;			// 02.11.28 ADD


// R[h̎
const TCHAR CodeListxx[NUM_SYMBOLOGIES][32] =
	{	TEXT("Code39"),		TEXT("NW 7"),		TEXT("WPCA"),
		TEXT("WPC"),		TEXT("UPCA"),		TEXT("UPC"),
		TEXT("IDF"),		TEXT("ITF"),		TEXT("CODE93"),
		TEXT("CODE128"),	TEXT("MSI"),		TEXT("IATA")
	};

BOOL CALLBACK ModeSetCodeOptionProc(HWND, UINT, WPARAM, LPARAM) ;





// Code Setting Dialog
BOOL CALLBACK ModeSetCodeOptionProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		iRet,i, Num1D;
	int		preCode;
	HWND	hTemp;
	BYTE	bMinwk,bMaxwk ;
	WORD	wRet ;
	NMHDR	*nmhdr;
	Num1D=12;

	switch (message)
	{
		case WM_INITDIALOG:
			// Insert Item to ComboBox
			giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
			gdwCdOpActFlg = 1 ;						// ޵߼ݐݒ豸è׸ ON 02.11.29 ADD
			gdwCdActFlg = 0 ;						// ޗLݒ豸è׸ OFF 02.11.29 ADD
			for (i=0; i<12; i++){
				SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)CodeList[CmbOrder[i]]);
			}
			for (i=0; i<iOutFormatSize[0]; i++){
				SendDlgItemMessage(hDlg, IDC_COMBO_OUTFORMAT, CB_ADDSTRING, 0
										, (LPARAM)OutFomatCd39List[i]);
			}
			for (i=0; i<iCheckDigitSize[0]; i++){
				SendDlgItemMessage(hDlg, IDC_COMBO_CHECKDIGIT, CB_ADDSTRING, 0
										, (LPARAM)CheckDigitAnyList[i]);
			}
			
			if((ObrModeTbl.Code & OBR_CD39) == OBR_CD39)
			{
				SendDlgItemMessage (hDlg, IDC_CHECK_ENABLE, BM_SETCHECK, BST_CHECKED, 0);
			}
			else
			{
				SendDlgItemMessage (hDlg, IDC_CHECK_ENABLE, BM_SETCHECK, BST_UNCHECKED, 0);
			}
			if(ObrModeTbl.Cd39[CHECKCHAROP] == OBR_CHKCON)
			{
				 SendDlgItemMessage (hDlg, IDC_CHECK_CHECKCH, BM_SETCHECK, BST_CHECKED, 0);
			}
			else
			{
				SendDlgItemMessage (hDlg, IDC_CHECK_CHECKCH, BM_SETCHECK, BST_UNCHECKED, 0);
			}
			hTemp	= GetDlgItem(hDlg, IDC_EMIN);
			ShowWindow(hTemp, (int)SW_SHOW);
			hTemp	= GetDlgItem(hDlg, IDC_EMAX);
			ShowWindow(hTemp, (int)SW_SHOW);
			gnowCode = 0 ;
			// Limit Data Range
			SendDlgItemMessage(hDlg, IDC_SPIN_EMIN, UDM_SETRANGE, 0, MAKELONG((short)iMax[gnowCode], (short)iMin[gnowCode]));
			SendDlgItemMessage(hDlg, IDC_SPIN_EMAX, UDM_SETRANGE, 0, MAKELONG((short)iMax[gnowCode], (short)iMin[gnowCode]));
			SendDlgItemMessage (hDlg, (int)IDC_COMBO1, (UINT)WM_SETTEXT, 0, (LPARAM)CodeList[0]);
			SendDlgItemMessage(	hDlg, (int)IDC_SPIN_EMIN, (UINT)UDM_SETPOS, 0, (LPARAM)cparam[0].bp[MINOP]);
			SendDlgItemMessage(	hDlg, (int)IDC_SPIN_EMAX, (UINT)UDM_SETPOS, 0, (LPARAM)cparam[0].bp[MAXOP]);
			SendDlgItemMessage(	hDlg, (int)IDC_COMBO_OUTFORMAT, (UINT)CB_SETCURSEL, cparam[0].bp[OUTFORMATOP], 0);
			SendDlgItemMessage(	hDlg, (int)IDC_COMBO_CHECKDIGIT, (UINT)CB_SETCURSEL, cparam[0].bp[CHECKDIGITOP],0);
			
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam)){
				case IDC_COMBO1:
				// ComboBox Changed
				if(HIWORD(wParam) == CBN_SELCHANGE){

					giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
					bMinwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN,UDM_GETPOS, 0, 0);
					bMaxwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX, UDM_GETPOS, 0, 0);
					if (bMinwk > bMaxwk)
					{
						MessageBox(hDlg, TEXT("Invalid Data Range"), TEXT("Parameter Error"), MB_OK);
						SendDlgItemMessage (hDlg, (int)IDC_COMBO1, (UINT)WM_SETTEXT, 0, (LPARAM)CodeList[gnowCode]);
					}
					else if (iMinOnOff[gnowCode] != 0)
					{											// ݒϗL ? 02.11.28 CHG
						cparam[gnowCode].bp[MINOP] = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN
																			,UDM_GETPOS, 0, 0);
						cparam[gnowCode].bp[MAXOP] = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX
																			, UDM_GETPOS, 0, 0);

					}
												// 02.11.28 CHG
					if(iOutFormatOnOff[gnowCode] !=0 )
						cparam[gnowCode].bp[OUTFORMATOP] =(BYTE) OutFomatCd128Order[SendDlgItemMessage(hDlg,IDC_COMBO_OUTFORMAT, CB_GETCURSEL, 0, 0) ];
												// 02.11.28 CHG
					if(iCheckDigitOnOff[gnowCode] != 0)
						cparam[gnowCode].bp[CHECKDIGITOP] =(BYTE) CheckDigitIataOrder[SendDlgItemMessage(hDlg,IDC_COMBO_CHECKDIGIT, CB_GETCURSEL, 0, 0) ];

					codeonoff[gnowCode].be = (WORD)SendDlgItemMessage( hDlg,IDC_CHECK_ENABLE, BM_GETCHECK, 0, 0);
					if (codeonoff[gnowCode].be == (WORD)BST_CHECKED) cparam[gnowCode].be = TRUE ;
					else if (codeonoff[gnowCode].be == (WORD)BST_UNCHECKED) cparam[gnowCode].be = FALSE ;
					SendDlgItemMessage(hDlg, IDC_CHECK_CODE39+gnowCode, BM_SETCHECK
										, codeonoff[gnowCode].be, 0);		// 02.11.28 ADD

//-- 02.11.28 ADD START ------------------------------------------------------------------------------------------
					if(iCheckCharOnOff[gnowCode] != 0)
					{
						wRet = (WORD)SendDlgItemMessage( hDlg,(int)IDC_CHECK_CHECKCH, (UINT)BM_GETCHECK, 0, 0);
						if (wRet == BST_CHECKED)
						{
							cparam[gnowCode].bp[CHECKCHAROP] = (BYTE)OBR_CHKCON ;
						}
						else if (wRet == BST_UNCHECKED)
						{
							cparam[gnowCode].bp[CHECKCHAROP] = (BYTE)OBR_CHKCOFF ;
						}
					}
//-- 02.11.28 ADD END ------------------------------------------------------------------------------------------
					preCode=gnowCode;						// Save Previous Code Number
					gnowCode = CmbOrder[ SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0) ];
					ShowParamCodeConfig(hDlg, preCode, gnowCode);


				}
				return TRUE;						// 02.11.28 ADD
				break;
				case IDC_COMBO_OUTFORMAT:
				if(HIWORD(wParam) == CBN_SELCHANGE){
					switch(gnowCode)
					{
						case SYM_CODE39:
							gnowCodeOutFormat = OutFomatCd39Order[SendDlgItemMessage(hDlg,IDC_COMBO_OUTFORMAT, CB_GETCURSEL, 0, 0) ];
							break ;
						case SYM_NW7:
							gnowCodeOutFormat = OutFomatNw7Order[SendDlgItemMessage(hDlg,IDC_COMBO_OUTFORMAT, CB_GETCURSEL, 0, 0) ];
							break ;
						case SYM_CODE128:
							gnowCodeOutFormat = OutFomatCd128Order[SendDlgItemMessage(hDlg,IDC_COMBO_OUTFORMAT, CB_GETCURSEL, 0, 0) ];
							break ;
						default:
							gnowCodeOutFormat = 0 ;
							break ;
					}
					cparam[gnowCode].bp[OUTFORMATOP] = gnowCodeOutFormat;
					giInidefFlag = 0 ;						// ini File ݒ FLAG OFF

				}
				break;
				case IDC_COMBO_CHECKDIGIT:
				if(HIWORD(wParam) == CBN_SELCHANGE){
					switch(gnowCode)
					{
						case SYM_MSI:
							gnowCodeCheckDigit = CheckDigitMsiOrder[SendDlgItemMessage(hDlg,IDC_COMBO_CHECKDIGIT, CB_GETCURSEL, 0, 0) ];
							break ;
						case SYM_IATA25:
							gnowCodeCheckDigit = CheckDigitIataOrder[SendDlgItemMessage(hDlg,IDC_COMBO_CHECKDIGIT, CB_GETCURSEL, 0, 0) ];
							break ;
						default:
							gnowCodeCheckDigit = CheckDigitAnyOrder[SendDlgItemMessage(hDlg,IDC_COMBO_CHECKDIGIT, CB_GETCURSEL, 0, 0) ];
							break ;
					}
					cparam[gnowCode].bp[CHECKDIGITOP] = gnowCodeCheckDigit;
					giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
				}
				break;
			}
			break;

			case WM_VSCROLL:
				bMinwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN,UDM_GETPOS, 0, 0);
				bMaxwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX, UDM_GETPOS, 0, 0);
				giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
				if (bMinwk > bMaxwk)
				{
					if (dwOnoffsw == 0)
					{
						MessageBox(hDlg, TEXT("Invalid Data Range"), TEXT("Parameter Error"), MB_OK);
						dwOnoffsw = 1 ;
					}
					else
					{
						dwOnoffsw = 0 ;
					}
				}
			break ;
		case WM_NOTIFY:
			nmhdr = (NMHDR*)lParam;
			switch(nmhdr->code){
				case PSN_SETACTIVE:
					gdwCdOpActFlg = 1 ;					// ޵߼ݐݒ豸è׸ ON 02.11.29 ADD
					gdwCdActFlg = 0 ;					// ޗLݒ豸è׸ OFF 02.11.29 ADD
					break;
				
				case PSN_KILLACTIVE:
					giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
					bMinwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN,UDM_GETPOS, 0, 0);
					bMaxwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX, UDM_GETPOS, 0, 0);
					if (bMinwk > bMaxwk)
					{
						MessageBox(hDlg, TEXT("Invalid Data Range"), TEXT("Parameter Error"), MB_OK);
						break ;
					}

					codeonoff[gnowCode].be = (WORD)SendDlgItemMessage( hDlg,(int)IDC_CHECK_ENABLE,(UINT)BM_GETCHECK, 0, 0);
					if (codeonoff[gnowCode].be == (WORD)BST_CHECKED) cparam[gnowCode].be = TRUE ;
					else if (codeonoff[gnowCode].be == (WORD)BST_UNCHECKED) cparam[gnowCode].be = FALSE ;
					cparam[Order1D[gnowCode]].bp[MINOP] = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN
																			,UDM_GETPOS, 0, 0);
					cparam[Order1D[gnowCode]].bp[MAXOP] = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX
																			, UDM_GETPOS, 0, 0);
					cparam[gnowCode].bp[OUTFORMATOP] =(BYTE) OutFomatCd128Order[SendDlgItemMessage(hDlg,IDC_COMBO_OUTFORMAT, CB_GETCURSEL, 0, 0) ];
					cparam[gnowCode].bp[CHECKDIGITOP] =(BYTE) CheckDigitIataOrder[SendDlgItemMessage(hDlg,IDC_COMBO_CHECKDIGIT, CB_GETCURSEL, 0, 0) ];
					wRet = (WORD)SendDlgItemMessage( hDlg,(int)IDC_CHECK_CHECKCH,(UINT)BM_GETCHECK, 0, 0);
					if (wRet == BST_CHECKED)
					{
						cparam[gnowCode].bp[CHECKCHAROP] = OBR_CHKCON ;
					}
					else if (wRet == BST_UNCHECKED)
					{
						cparam[gnowCode].bp[CHECKCHAROP] = OBR_CHKCOFF ;
					}
					TST_GetCodests();				// CODEL/ݒ
					TST_GetCodeOption() ;			// CODEIvVL/ݒ擾
					return TRUE;

				case PSN_APPLY:

										// Ini File Write׸ON or ޵߼ݐݒ豸è׸ OFF? 02.11.29 ADD
					if ((giInidefFlag == 1) || (gdwCdOpActFlg == 0))
					{
						return FALSE;
					}

					bMinwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN,UDM_GETPOS, 0, 0);
					bMaxwk = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX, UDM_GETPOS, 0, 0);
					if (bMinwk > bMaxwk)
					{
						MessageBox(hDlg, TEXT("Invalid Data Range"), TEXT("Parameter Error"), MB_OK);
						break ;
					}
					codeonoff[gnowCode].be = (WORD)SendDlgItemMessage( hDlg,(int)IDC_CHECK_ENABLE
																		,(UINT)BM_GETCHECK, 0, 0);
					if (codeonoff[gnowCode].be == BST_CHECKED) cparam[gnowCode].be = TRUE ;
					else if (codeonoff[gnowCode].be == BST_UNCHECKED) cparam[gnowCode].be = FALSE ;
					cparam[Order1D[gnowCode]].bp[MINOP] = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN
																			,UDM_GETPOS, 0, 0);
					cparam[Order1D[gnowCode]].bp[MAXOP] = (BYTE)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX
																			, UDM_GETPOS, 0, 0);
					cparam[gnowCode].bp[OUTFORMATOP] =(BYTE) OutFomatCd128Order[SendDlgItemMessage(hDlg,IDC_COMBO_OUTFORMAT, CB_GETCURSEL, 0, 0) ];
					cparam[gnowCode].bp[CHECKDIGITOP] =(BYTE) CheckDigitIataOrder[SendDlgItemMessage(hDlg,IDC_COMBO_CHECKDIGIT, CB_GETCURSEL, 0, 0) ];
					wRet = (WORD)SendDlgItemMessage( hDlg,(int)IDC_CHECK_CHECKCH,(UINT)BM_GETCHECK, 0, 0);
					if (wRet == BST_CHECKED)
					{
						cparam[gnowCode].bp[CHECKCHAROP] = OBR_CHKCON ;
					}
					else if (wRet == BST_UNCHECKED)
					{
						cparam[gnowCode].bp[CHECKCHAROP] = OBR_CHKCOFF ;
					}
					TST_GetCodests();				// CODEL/ݒ
					TST_GetCodeOption() ;			// CODEIvVL/ݒ擾
					iRet = ini_FileWrite_Proc() ;	// ini File ݏ
					gdwCdOpActFlg = 0 ;				// ޵߼ݐݒ豸è׸ OFF 02.11.29 ADD
					return TRUE;					// 02.11.28 ADD
					break;
				case PSN_QUERYCANCEL:
					break;
				default:
					return FALSE;
			}
			break;

	}
    return FALSE;
}
