

#define dim(x) (sizeof(x) / sizeof(x[0]))



#define	OBR_CODE_CD39	0
#define	OBR_CODE_NW7	1
#define	OBR_CODE_WPCA	2
#define	OBR_CODE_WPC	3
#define	OBR_CODE_UPCA	4
#define	OBR_CODE_UPC	5
#define	OBR_CODE_IDF	6
#define	OBR_CODE_ITF	7
#define	OBR_CODE_CD93	8
#define	OBR_CODE_CD128	9
#define	OBR_CODE_MSI	10
#define	OBR_CODE_IATA	11

#define	MINOP			1
#define	MAXOP			2
#define	OUTFORMATOP		3
#define	CHECKDIGITOP	4
#define	CHECKCHAROP		5

//#define	SYM_CODE128AON	0
//#define	SYM_CODE128AOFF	1
//#define	SYM_CODE128EAN	2
//#define	SYM_CODE128AIM	6
//#define	SYM_CODE128FNC	10



//#define	SYM_BUFOBR		0
//#define	SYM_STOF		2
//#define	SYM_ASTOF		3

#define	OBR_CHKCON		1
#define	OBR_CHKCOFF		0

#define	OBR_128AIM		6
#define	OBR_128FNC		10

#define	_FILE_CHK_LNG	24		// ̧ٖ`ݸ޽
#define _INIDEF_LNG		24				// ftHginit@COX
#define	base_HEX_char	16			// toϊ̊HEXi16j
#define	base_DEC_char	10			// toϊ̊DECi10j

#define	CODEOPTION_SIZE	6

    //-----------------------------------------------------------------------------
    // Symbology selection constants
    //-----------------------------------------------------------------------------
    enum
    {
        SYM_CODE39 = 0,
        SYM_NW7,
        SYM_WPCA,
        SYM_WPC,
        SYM_UPCA,
        SYM_UPC,
        SYM_IDF25,
        SYM_ITF25,
        SYM_CODE93,
        SYM_CODE128,
        SYM_MSI,
        SYM_IATA25,
        NUM_SYMBOLOGIES
    };

    enum
    {
        SYM_CODE39SON = 0,
        SYM_CODE39SOFF,
        SYM_CODE39ASON,
        CODE39ASOFF,
        NUM_SYMBOL_OUTCD39
    };

    enum
    {
        SYM_NW7SON = 0,
        SYM_NW7SOFF,
        NUM_SYMBOL_OUTNW7
    };
    enum
    {
        SYM_CODE128AON = 0,
        SYM_CODE128AOFF,
        SYM_CODE128EAN,
        SYM_CODE128AIM,
        SYM_CODE128FNC,
        NUM_SYMBOL_OUT128
    };

    enum
    {
        SYM_CHKDOFF = 0,
        SYM_CHKDON,
        SYM_CMDSEV,
        SYM_CMDSTN,
        NUM_SYMBOL_CHKD
    };

    enum
    {
        SYM_TYPE0 = 0,
        SYM_TYPE1,
        NUM_SYMBOL_RDMODE
    };

    enum
    {
        SYM_BUZOFF = 0,
        SYM_BUZON,
        NUM_SYMBOL_BUZZER
    };

    enum
    {
        SYM_LEDOFF = 0,
        SYM_LEDON,
        SYM_LEDEROF,
        NUM_SYMBOL_LED
    };
    enum
    {
        SYM_BUFOBR = 0,
        SYM_STOF,
        SYM_ASTOF,
        NUM_SYMBOL_OUTBUF
    };


    enum
    {
        SYM_NORM = 0,
        SYM_DANN,
        NUM_SYMBOL_MDACT
    };

    enum
    {
        SYM_ENDCR = 0,
        SYM_ENDLF,
        SYM_ENDCL,
        NUM_SYMBOL_ENDCHA
    };


//=== 02.12.20 ADD START ==================================
    enum
    {
		SYM_NOFILTER = 0,
		SYM_SOFTFILTER,
		SYM_HARDFILTER,
		SYM_SOFTHARDFILTER
    };
//==========================================================

struct CODEPARAM{
	BOOL	be;		// Enable/Disable
	BYTE	bp[6];	// Etc Parameters
};

struct CODEONOFF{
	WORD	be;		// Enable/Disable
};

