#include <windows.h>				// 
#include <winbase.h>				// 
#include <stdlib.h>	
#include "resource.h"
#include "Set1D_def.h"
#include "OBRREQ.h"
#include <commctrl.h>
#include <prsht.h>                   // vpeB V[g̃CN[h

#define MAX_LOADSTRING 100

// Global Variables:
extern HINSTANCE			hInst;			// The current instance
extern HWND				hwndCB;			// The command bar handle

// Code Setting
extern int	gnowCode;
extern int	gnowCodeCheckDigit ;
extern int	gnowCodeOutFormat ;
extern int	gnowCodeReadMode ; 
extern int	gnowCodeBuzzer ;
extern int	gnowCodeLed ;
extern int	gnowCodeOutBuff ;
extern int	gnowCodeEndCode ;
extern int	gnowCodeReadActMode ;



extern struct CODEPARAM	cparam[NUM_SYMBOLOGIES];	// Code Parameter
extern struct CODEONOFF	codeonoff[NUM_SYMBOLOGIES];	// Code Enable/Disble

// Code Range / min digit / max digit
extern const int iMin[NUM_SYMBOLOGIES] ;
extern const int iMax[NUM_SYMBOLOGIES] ;

extern const int iMinOnOff[NUM_SYMBOLOGIES] ;
extern const int iMaxOnOff[NUM_SYMBOLOGIES] ;
extern const int iOutFormatOnOff[NUM_SYMBOLOGIES] ;
extern const int iCheckDigitOnOff[NUM_SYMBOLOGIES] ;
extern const int iCheckCharOnOff[NUM_SYMBOLOGIES] ;



// R[h̎
extern const TCHAR CodeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CmbOrder[NUM_SYMBOLOGIES] ;
extern int Order1D[14] ;

extern const int iOutFormatSize[NUM_SYMBOLOGIES] ;
// OUTFORMAT CODE39̎
extern const TCHAR OutFomatCd39List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatCd39Order[NUM_SYMBOLOGIES] ;
// OUTFORMAT NW7̎
extern const TCHAR OutFomatNw7List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatNw7Order[NUM_SYMBOLOGIES] ;
// OUTFORMAT CODE128̎
extern const TCHAR OutFomatCd128List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatCd128Order[NUM_SYMBOLOGIES] ;
extern const int iCheckDigitSize[NUM_SYMBOLOGIES] ;
// Check Digit MSI̎
extern const TCHAR CheckDigitMsiList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitMsiOrder[NUM_SYMBOLOGIES] ;
// Check Digit IATA̎
extern const TCHAR CheckDigitIataList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitIataOrder[NUM_SYMBOLOGIES] ;
// Check Digit ̑̎
extern const TCHAR CheckDigitAnyList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitAnyOrder[NUM_SYMBOLOGIES] ;
// ǂݎ胂[h ̎
extern const TCHAR ReadModeList[NUM_SYMBOL_RDMODE][32] ;
// Combobox Order
extern int ReadModeOrder[NUM_SYMBOL_RDMODE] ;
// uU[ ̎
extern const TCHAR BuzzerList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int BuzzerOrder[NUM_SYMBOLOGIES] ;
// kdc ̎
extern const TCHAR LedList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int LedOrder[NUM_SYMBOLOGIES] ;
// o̓obt@ ̎
extern const TCHAR OutBuffList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutBuffOrder[NUM_SYMBOLOGIES] ;
// ǂݎ蓮샂[h ̎
extern const TCHAR ReadActModeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int ReadActModeOrder[NUM_SYMBOLOGIES] ;
// IR[h ̎
extern const TCHAR EndCodeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int EndCodeOrder[NUM_SYMBOLOGIES] ;

// tB^[h ̎ 02.12.20 ADD
extern const TCHAR FilterModeList[NUM_SYMBOLOGIES][32];
extern int FilterModeOrder[NUM_SYMBOLOGIES] ;

extern int giInidefFlag  ;						// ini File ݒ FLAG

extern const	struct	m_tbl	ObrModeTblDef ;
extern struct	m_tbl	ObrModeTbl ;






extern void	TST_GetCodests(void);				// CODEL/ݒ
extern void	TST_GetCodeOption(void) ;			// CODEIvVL/ݒ擾
extern int ini_FileWrite_Proc(void) ;			//
extern int	TST_SetCodeOptinGet(HWND) ;			// 02.11.26 ADD
extern void ModeSetGetData(HWND) ;				// Mode Settings GET
extern void ModeData_Set(HWND) ;




//extern CODEPARAM	cparam[NUM_SYMBOLOGIES];	// Code Parameter



BOOL CALLBACK SetToolProc(HWND, UINT, WPARAM, LPARAM) ;





BOOL CALLBACK SetToolProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int		Num1D,iRet;
	NMHDR	*nmhdr;
	Num1D=12;
	
	switch (message)
	{
		case WM_COMMAND:
			switch(LOWORD(wParam)){
				case IDC_BUTTON_DEFALT:
					if (HIWORD (wParam) == BN_CLICKED)
					{		// {^ ?
						ObrModeTbl = ObrModeTblDef ;			// ݒ̫ SET 02.11.25 ADD
						iRet = TST_SetCodeOptinGet(hDlg) ;		// Code Option Get
						ModeData_Set(hDlg) ;
						ObrModeTbl = ObrModeTblDef ;			// ݒ̫ SET 02.11.25 ADD
						iRet = ini_FileWrite_Proc() ;			// ini File ݏ
						giInidefFlag = 1 ;						// ini File ݒ FLAG ON
					}
					break ;
				case IDC_BUTTON_LOGGET:							// LogGETv 03.01.14 ADD
					if (HIWORD (wParam) == BN_CLICKED)
					{		// {^ ?
						iRet = OBRIntLogRequest() ;				// LogGET 03.01.14 ADD
					}
					break ;
				default:
					return FALSE;
			}
			break ;
		case WM_NOTIFY:
			nmhdr = (NMHDR*)lParam;
			switch(nmhdr->code){
				case PSN_SETACTIVE:
					break;
				
				case PSN_KILLACTIVE:
					return TRUE;
				
				case PSN_APPLY:
					if (giInidefFlag == 1)
					{
						giInidefFlag = 0;
					}

					return TRUE;
					break;
				case PSN_QUERYCANCEL:
					break;
				default:
					return FALSE;
			}
			break;
	}// switch(message)
    return FALSE;
}



